#include <Eibrielex.h>

Eibrielex axisA(25, 16, 6, 7, 8, 9, 0);
Eibrielex axisB(25, 16, 10, 11, 12, 13, 0);
Eibrielex axisC(25, 6, 3, 3, 4, 5, 0);

int incomingByte;
byte uno;
int enframeA;
int enframeB;
int enframeC;

void setup() {                
  Serial.begin(115200);
  uno = 0;
  
  enframeA=0;
  enframeB=0;
  enframeC=0;
  Serial.write(1);
  //pinMode(13, OUTPUT);
}

void loop() {

  if (Serial.available() > 0) {
    incomingByte = Serial.read();
    
    multihandrer ();
    
    if (uno==0) {
      enframeA = enframeA + incomingByte;
      enframeA = enframeA - 128;
      
      if (!axisA.Working()) {
        axisA.Steps( enframeA );
        enframeA=0;
      }
      uno = 1;
    } else if (uno==1) {
      enframeB = enframeB + incomingByte;
      enframeB = enframeB - 128;
      
      if (!axisB.Working()) {
        axisB.Steps( enframeB );
        enframeB=0;
      }
      uno = 2;
    } else if (uno==2) {
    
      enframeC = enframeC + incomingByte;
      enframeC = enframeC - 128;
      
      if (!axisC.Working()) {
        axisC.Steps( enframeC );
        enframeC=0;
      }
      uno = 0;
      //whaitToWrite() ;
      //if (readyToWrite()) {
        /*
        while ( !(UCSR0A & (1<<UDRE0)) ) {
          multihandrer ();
        }
        */
        //while (!UDRE0);
        //Serial.waitToWrite();
        Serial.write(1);
        //Serial.flush();
        //while (!(UCSR0A & _BV(TXC0))) {
        //  multihandrer ();
        //}
      //}
      //Serial.flush();
      //Serial.println(incomingByte);
    }
    
  }
  
  multihandrer ();

}

void multihandrer () {
  //digitalWrite(13, HIGH);
  axisA.Handle();
  axisB.Handle();
  axisC.Handle();
  //digitalWrite(13, LOW);
}

void whaitToWrite() {
  while (!((UCSR0A) & (1 << UDRE0))) {
  //while ( (UCSR0A & _BV(UDRE0)) == 0 ) {
  //while ( (UCSR0A & _BV(TXC0)) == 0 ) {
    //Serial.flush();
    multihandrer ();
  }
}

boolean readyToWrite() {
  //return (UCSR0A & _BV(UDRE0));
}
